]> git.proxmox.com Git - mirror_qemu.git/blob - scripts/qemu-binfmt-conf.sh
linux-user: allows to use "--systemd ALL" with qemu-binfmt-conf.sh
[mirror_qemu.git] / scripts / qemu-binfmt-conf.sh
1 #!/bin/sh
2 # enable automatic i386/ARM/M68K/MIPS/SPARC/PPC/s390/HPPA
3 # program execution by the kernel
4
5 qemu_target_list="i386 i486 alpha arm armeb sparc32plus ppc ppc64 ppc64le m68k \
6 mips mipsel mipsn32 mipsn32el mips64 mips64el \
7 sh4 sh4eb s390x aarch64 aarch64_be hppa riscv32 riscv64"
8
9 i386_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x03\x00'
10 i386_mask='\xff\xff\xff\xff\xff\xfe\xfe\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
11 i386_family=i386
12
13 i486_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x06\x00'
14 i486_mask='\xff\xff\xff\xff\xff\xfe\xfe\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
15 i486_family=i386
16
17 alpha_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x26\x90'
18 alpha_mask='\xff\xff\xff\xff\xff\xfe\xfe\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
19 alpha_family=alpha
20
21 arm_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28\x00'
22 arm_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
23 arm_family=arm
24
25 armeb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28'
26 armeb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
27 armeb_family=armeb
28
29 sparc_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x02'
30 sparc_mask='\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
31 sparc_family=sparc
32
33 sparc32plus_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x12'
34 sparc32plus_mask='\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
35 sparc32plus_family=sparc
36
37 ppc_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x14'
38 ppc_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
39 ppc_family=ppc
40
41 ppc64_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x15'
42 ppc64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
43 ppc64_family=ppc
44
45 ppc64le_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x15\x00'
46 ppc64le_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\x00'
47 ppc64le_family=ppcle
48
49 m68k_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x04'
50 m68k_mask='\xff\xff\xff\xff\xff\xff\xfe\xfe\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
51 m68k_family=m68k
52
53 # FIXME: We could use the other endianness on a MIPS host.
54
55 mips_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08'
56 mips_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
57 mips_family=mips
58
59 mipsel_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00'
60 mipsel_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
61 mipsel_family=mips
62
63 mipsn32_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08'
64 mipsn32_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
65 mipsn32_family=mips
66
67 mipsn32el_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00'
68 mipsn32el_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
69 mipsn32el_family=mips
70
71 mips64_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08'
72 mips64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
73 mips64_family=mips
74
75 mips64el_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00'
76 mips64el_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
77 mips64el_family=mips
78
79 sh4_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x2a\x00'
80 sh4_mask='\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
81 sh4_family=sh4
82
83 sh4eb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x2a'
84 sh4eb_mask='\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
85 sh4eb_family=sh4
86
87 s390x_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x16'
88 s390x_mask='\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
89 s390x_family=s390x
90
91 aarch64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7\x00'
92 aarch64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
93 aarch64_family=arm
94
95 aarch64_be_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7'
96 aarch64_be_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
97 aarch64_be_family=armeb
98
99 hppa_magic='\x7f\x45\x4c\x46\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x0f'
100 hppa_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
101 hppa_family=hppa
102
103 riscv32_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xf3\x00'
104 riscv32_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
105 riscv32_family=riscv
106
107 riscv64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xf3\x00'
108 riscv64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
109 riscv64_family=riscv
110
111 qemu_get_family() {
112 cpu=${HOST_ARCH:-$(uname -m)}
113 case "$cpu" in
114 amd64|i386|i486|i586|i686|i86pc|BePC|x86_64)
115 echo "i386"
116 ;;
117 mips*)
118 echo "mips"
119 ;;
120 "Power Macintosh"|ppc64|powerpc|ppc)
121 echo "ppc"
122 ;;
123 ppc64el|ppc64le)
124 echo "ppcle"
125 ;;
126 arm|armel|armhf|arm64|armv[4-9]*l|aarch64)
127 echo "arm"
128 ;;
129 armeb|armv[4-9]*b|aarch64_be)
130 echo "armeb"
131 ;;
132 sparc*)
133 echo "sparc"
134 ;;
135 riscv*)
136 echo "riscv"
137 ;;
138 *)
139 echo "$cpu"
140 ;;
141 esac
142 }
143
144 usage() {
145 cat <<EOF
146 Usage: qemu-binfmt-conf.sh [--qemu-path PATH][--debian][--systemd CPU]
147 [--help][--credential yes|no][--exportdir PATH]
148
149 Configure binfmt_misc to use qemu interpreter
150
151 --help: display this usage
152 --qemu-path: set path to qemu interpreter ($QEMU_PATH)
153 --debian: don't write into /proc,
154 instead generate update-binfmts templates
155 --systemd: don't write into /proc,
156 instead generate file for systemd-binfmt.service
157 for the given CPU. If CPU is "ALL", generate a
158 file for all known cpus
159 --exportdir: define where to write configuration files
160 (default: $SYSTEMDDIR or $DEBIANDIR)
161 --credential: if yes, credential and security tokens are
162 calculated according to the binary to interpret
163
164 To import templates with update-binfmts, use :
165
166 sudo update-binfmts --importdir ${EXPORTDIR:-$DEBIANDIR} --import qemu-CPU
167
168 To remove interpreter, use :
169
170 sudo update-binfmts --package qemu-CPU --remove qemu-CPU $QEMU_PATH
171
172 With systemd, binfmt files are loaded by systemd-binfmt.service
173
174 The environment variable HOST_ARCH allows to override 'uname' to generate
175 configuration files for a different architecture than the current one.
176
177 where CPU is one of:
178
179 $qemu_target_list
180
181 EOF
182 }
183
184 qemu_check_access() {
185 if [ ! -w "$1" ] ; then
186 echo "ERROR: cannot write to $1" 1>&2
187 exit 1
188 fi
189 }
190
191 qemu_check_bintfmt_misc() {
192 # load the binfmt_misc module
193 if [ ! -d /proc/sys/fs/binfmt_misc ]; then
194 if ! /sbin/modprobe binfmt_misc ; then
195 exit 1
196 fi
197 fi
198 if [ ! -f /proc/sys/fs/binfmt_misc/register ]; then
199 if ! mount binfmt_misc -t binfmt_misc /proc/sys/fs/binfmt_misc ; then
200 exit 1
201 fi
202 fi
203
204 qemu_check_access /proc/sys/fs/binfmt_misc/register
205 }
206
207 installed_dpkg() {
208 dpkg --status "$1" > /dev/null 2>&1
209 }
210
211 qemu_check_debian() {
212 if [ ! -e /etc/debian_version ] ; then
213 echo "WARNING: your system is not a Debian based distro" 1>&2
214 elif ! installed_dpkg binfmt-support ; then
215 echo "WARNING: package binfmt-support is needed" 1>&2
216 fi
217 qemu_check_access "$EXPORTDIR"
218 }
219
220 qemu_check_systemd() {
221 if ! systemctl -q is-enabled systemd-binfmt.service ; then
222 echo "WARNING: systemd-binfmt.service is missing or disabled" 1>&2
223 fi
224 qemu_check_access "$EXPORTDIR"
225 }
226
227 qemu_generate_register() {
228 echo ":qemu-$cpu:M::$magic:$mask:$qemu:$FLAGS"
229 }
230
231 qemu_register_interpreter() {
232 echo "Setting $qemu as binfmt interpreter for $cpu"
233 qemu_generate_register > /proc/sys/fs/binfmt_misc/register
234 }
235
236 qemu_generate_systemd() {
237 echo "Setting $qemu as binfmt interpreter for $cpu for systemd-binfmt.service"
238 qemu_generate_register > "$EXPORTDIR/qemu-$cpu.conf"
239 }
240
241 qemu_generate_debian() {
242 cat > "$EXPORTDIR/qemu-$cpu" <<EOF
243 package qemu-$cpu
244 interpreter $qemu
245 magic $magic
246 mask $mask
247 EOF
248 if [ "$FLAGS" = "OC" ] ; then
249 echo "credentials yes" >> "$EXPORTDIR/qemu-$cpu"
250 fi
251 }
252
253 qemu_set_binfmts() {
254 # probe cpu type
255 host_family=$(qemu_get_family)
256
257 # register the interpreter for each cpu except for the native one
258
259 for cpu in ${qemu_target_list} ; do
260 magic=$(eval echo \$${cpu}_magic)
261 mask=$(eval echo \$${cpu}_mask)
262 family=$(eval echo \$${cpu}_family)
263
264 if [ "$magic" = "" ] || [ "$mask" = "" ] || [ "$family" = "" ] ; then
265 echo "INTERNAL ERROR: unknown cpu $cpu" 1>&2
266 continue
267 fi
268
269 qemu="$QEMU_PATH/qemu-$cpu"
270 if [ "$cpu" = "i486" ] ; then
271 qemu="$QEMU_PATH/qemu-i386"
272 fi
273
274 if [ "$host_family" != "$family" ] ; then
275 $BINFMT_SET
276 fi
277 done
278 }
279
280 CHECK=qemu_check_bintfmt_misc
281 BINFMT_SET=qemu_register_interpreter
282
283 SYSTEMDDIR="/etc/binfmt.d"
284 DEBIANDIR="/usr/share/binfmts"
285
286 QEMU_PATH=/usr/local/bin
287 FLAGS=""
288
289 options=$(getopt -o ds:Q:e:hc: -l debian,systemd:,qemu-path:,exportdir:,help,credential: -- "$@")
290 eval set -- "$options"
291
292 while true ; do
293 case "$1" in
294 -d|--debian)
295 CHECK=qemu_check_debian
296 BINFMT_SET=qemu_generate_debian
297 EXPORTDIR=${EXPORTDIR:-$DEBIANDIR}
298 ;;
299 -s|--systemd)
300 CHECK=qemu_check_systemd
301 BINFMT_SET=qemu_generate_systemd
302 EXPORTDIR=${EXPORTDIR:-$SYSTEMDDIR}
303 shift
304 # check given cpu is in the supported CPU list
305 if [ "$1" != "ALL" ] ; then
306 for cpu in ${qemu_target_list} ; do
307 if [ "$cpu" = "$1" ] ; then
308 break
309 fi
310 done
311
312 if [ "$cpu" = "$1" ] ; then
313 qemu_target_list="$1"
314 else
315 echo "ERROR: unknown CPU \"$1\"" 1>&2
316 usage
317 exit 1
318 fi
319 fi
320 ;;
321 -Q|--qemu-path)
322 shift
323 QEMU_PATH="$1"
324 ;;
325 -e|--exportdir)
326 shift
327 EXPORTDIR="$1"
328 ;;
329 -h|--help)
330 usage
331 exit 1
332 ;;
333 -c|--credential)
334 shift
335 if [ "$1" = "yes" ] ; then
336 FLAGS="OC"
337 else
338 FLAGS=""
339 fi
340 ;;
341 *)
342 break
343 ;;
344 esac
345 shift
346 done
347
348 $CHECK
349 qemu_set_binfmts